-- ******************************** Variables *******************************
local L = LibStub("AceLocale-3.0"):GetLocale("Titan", true)
local LB = LibStub("AceLocale-3.0"):GetLocale("TitanPals", true)
-- ******************************** Functions *******************************

-- **************************************************************************
-- NAME : TitanPanelPalsButton_SetTooltipText()
-- DESC : Build Firends Tooltip for Titan Panel
-- **************************************************************************
function TitanPanelPalsButton_SetTooltip()
     GameTooltip:SetText(LB["TITAN_PALS_TOOLTIP"], HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b);
     local NumPals = GetNumFriends();
     local OnlinePals = 0;
     local OnlinePals_name, OnlinePals_level, OnlinePals_class, OnlinePals_area, OnlinePals_connected, OnlinePals_status, OnlinePals_note
     if ( NumPals == 0 ) then GameTooltip:AddLine("Your Pals List Is Currently Empty!!!") end
     for OnlinefriendIndex=1, NumPals do
          OnlinePals_name, OnlinePals_level, OnlinePals_class, OnlinePals_area, OnlinePals_connected, OnlinePals_status, OnlinePals_note = GetFriendInfo(OnlinefriendIndex);
          local TitanPals_ColoredNamePlate, TitanPals_AreaInfo
          if ( OnlinePals_connected ) then
               --TitanPanelPals_UpdatePals(OnlinePals_name, OnlinePals_level, OnlinePals_class, OnlinePals_area, OnlinePals_note);
               TitanPals_ColoredNamePlate = TitanPanelPals_PopulateName(OnlinePals_status, OnlinePals_level, OnlinePals_class, OnlinePals_name);
               TitanPals_AreaInfo = TitanPanelPals_ColorUtils("GetCText", "normal", OnlinePals_area)
               OnlinePals = OnlinePals + 1;
               if ( TitanPals["ShowNote"] ) then
                    if ( OnlinePals_note ) then OnlinePals_note = "("..OnlinePals_note..")"; TitanPals_AreaInfo = TitanPanelPals_ColorUtils("GetCText", "gray", OnlinePals_note).." "..TitanPals_AreaInfo; end
               end
          end
          GameTooltip:AddDoubleLine(TitanPals_ColoredNamePlate, TitanPanelPals_ColorUtils("GetCText", "hlight", TitanPals_AreaInfo));
          if ( OnlinePals == 0 ) then GameTooltip:AddLine("No Pals Currently Online"); end
     end
     if ( NumPals > 0 ) then
          if ( TitanPals["ShowOffline"] ) then
               GameTooltip:AddLine("\n");
               GameTooltip:AddLine(TitanPanelPals_ColorUtils("GetCText", "hlight", LB["TITAN_PALS_TOOLTIP_OFF"]));
               for OfflinefriendIndex=1, NumPals do
                    OfflinePals_name, OfflinePals_level, OfflinePals_class, OfflinePals_area, OfflinePals_connected, OfflinePals_status, OfflinePals_note = GetFriendInfo(OfflinefriendIndex);
                    --opn, opl, opcl, opa, opno =;
                    TitanPals_ColoredNamePlate = TitanPanelPals_PopulateName(OfflinePals_status, OfflinePals_level, OfflinePals_class, OfflinePals_name)
                    TitanPals_AreaInfo = "<Offline>"
                    if ( TitanPals["ShowNote"] and OfflinePals_note ) then TitanPals_AreaInfo = TitanPanelPals_ColorUtils("GetCText", "gray", "("..OfflinePals_note..")")..TitanPals_AreaInfo end
                         if ( not OfflinePals_connected ) then
                              if ( TitanPals["NoAlts"] and not TitanPals["Alts"][TitanPals["Faction"]][TitanPals["Realm"]][OfflinePals_name] ) then
                                   GameTooltip:AddDoubleLine(TitanPals_ColoredNamePlate, TitanPanelPals_ColorUtils("GetCText", "gray", TitanPals_AreaInfo));
                              end
                              if ( not TitanPals["NoAlts"] ) then 
                                   GameTooltip:AddDoubleLine(TitanPals_ColoredNamePlate, TitanPanelPals_ColorUtils("GetCText", "gray", TitanPals_AreaInfo));
                              end
                         end
                    end
               end
               if ( TitanPals["ShowIgnored"] ) then
                    GameTooltip:AddLine("\n");
                    GameTooltip:AddLine(TitanPanelPals_ColorUtils("GetCText", "hlight", LB["TITAN_PALS_TOOLTIP_IGNORED"]));
                    Numignored = GetNumIgnores();
                    if ( Numignored == 0 ) then GameTooltip:AddLine("Your ignore list is currently empty.");
                    else for ignoredIndex=1, Numignored do
                         if (not OfflinePals_connected ) then
                              local TitanPals_IgnoredTxt = TitanPanelPals_ColorUtils("GetCText", "red", "<Ignored>")
                              GameTooltip:AddDoubleLine("  "..TitanPanelPals_ColorUtils("GetCText", "normal", GetIgnoreName(ignoredIndex)), TitanPals_IgnoredTxt);
                         end
                    end
               end
          end
     end
     if ( TitanPals["ShowMem"] ) then
          GameTooltip:AddLine("\n");
          GameTooltip:AddLine(TitanPanelPals_ColorUtils("GetCText", "hlight", LB["TITAN_PALS_TOOLTIP_MEM"]));
	  GameTooltip:AddDoubleLine("Titan Panel [|cffeda55fPals|r]", TitanPanelPals_ColorUtils("GetCText", "green", floor(GetAddOnMemoryUsage('TitanPals')).."kb"))
     end
end

-- **************************************************************************
-- NAME : TitanPanelPals_PopulateName()
-- DESC : <research>
-- **************************************************************************
function TitanPanelPals_PopulateName(status, level, class, name)
	if ( status ) then status = status.." "; end;
	if (level == 0) then level = "-"; end
	if ( TitanPals["ShowClass"] ) then
		return "  "..status.." ("..TitanPanelPals_ColorUtils("GetCText", "orange", level).." "..TitanPanelPals_ColorUtils("GetCClass", "color", class, class)..") "..name;
	else
		return "  "..status.."("..TitanPanelPals_ColorUtils("GetCText", "orange", level)..") "..TitanPanelPals_ColorUtils("GetCClass", "color", class, name);
	end
end

-- **************************************************************************
-- NAME : TitanPanelPals_AddPals()
-- DESC : <research>
-- **************************************************************************
function TitanPanelPals_AddPals(name, level, class, area, note)
	local TitanPalsFaction = UnitFactionGroup("player");
	local TitanPalsRealm = GetCVar("realmName");
	local TitanPalsRealmUnit = GetUnitName("player");
	if ( not TitanPals[TitanPalsFaction][TitanPalsRealm][TitanPalsRealmUnit][name] ) then 
		TitanPals[TitanPalsFaction][TitanPalsRealm][TitanPalsRealmUnit][name] = {};
		TitanPals[TitanPalsFaction][TitanPalsRealm][TitanPalsRealmUnit][name].name = name;
		TitanPals[TitanPalsFaction][TitanPalsRealm][TitanPalsRealmUnit][name].level = level;
		TitanPals[TitanPalsFaction][TitanPalsRealm][TitanPalsRealmUnit][name].class = class;
		TitanPals[TitanPalsFaction][TitanPalsRealm][TitanPalsRealmUnit][name].area = area;
		if ( note ) then TitanPals[TitanPalsFaction][TitanPalsRealm][TitanPalsRealmUnit][name].note = note; end
	end
end

-- **************************************************************************
-- NAME : TitanPanelPals_UpdatePals()
-- DESC : <research>
-- **************************************************************************
function TitanPanelPals_UpdatePals(name, level, class, area, note)
	local TitanPalsFaction = UnitFactionGroup("player");
	local TitanPalsRealm = GetCVar("realmName");
	local TitanPalsRealmUnit = GetUnitName("player");
	if ( name ) then TitanPals[TitanPalsFaction][TitanPalsRealm][TitanPalsRealmUnit][name].name = name; end
	if ( level ) then TitanPals[TitanPalsFaction][TitanPalsRealm][TitanPalsRealmUnit][name].level = level; end
	if ( class ) then TitanPals[TitanPalsFaction][TitanPalsRealm][TitanPalsRealmUnit][name].class = class; end
	if ( area ) then TitanPals[TitanPalsFaction][TitanPalsRealm][TitanPalsRealmUnit][name].area = area; end
	if ( note ) then TitanPals[TitanPalsFaction][TitanPalsRealm][TitanPalsRealmUnit][name].note = note; end
end

-- **************************************************************************
-- NAME : TitanPanelPals_FixPalsEcho()
-- DESC : <research>
-- **************************************************************************
function TitanPanelPals_FixPalsEcho(level, class, name)		
	local class = TitanPalsUtils_ClassToColor("color", class, class)
	local name = TitanPalsUtils_ClassToColor("color", class, name)
	return "Fixing Pals ["..name.."] Class = ["..class.."] Level = ["..TitanPalsUtils_GetColoredText("orange", level).."]";
end

-- **************************************************************************
-- NAME : TitanPalsUtils_FixPal()
-- DESC : <research>
-- **************************************************************************
function TitanPalsUtils_FixPal(PN, PC, PL)
	if ( PC == "1" ) then PC = "Warrior"
	elseif ( PC == "2" ) then PC = "Mage"
	elseif ( PC == "3" ) then PC = "Warlock"
	elseif ( PC == "4" ) then PC = "Paladin"
	elseif ( PC == "5" ) then PC = "Priest"
	elseif ( PC == "6" ) then PC = "Hunter"
	elseif ( PC == "7" ) then PC = "Shaman"
	elseif ( PC == "8" ) then PC = "Rogue"
	elseif ( PC == "9" ) then PC = "Druid"
	elseif ( PC == "10" ) then PC = "Death Knight" end
	local printLine = TitanPanelPals_FixPalsEcho(PL, PC, PN)
	TitanPalsUtils_Print(printLine);
	local TPF = UnitFactionGroup("player");
	local TPR = GetCVar("realmName");
	local TPRU = GetUnitName("player");
	TitanPals[TPF][TPR][TPRU][PN].class = PC
	TitanPals[TPF][TPR][TPRU][PN].level = PL
end